<?php
/**
 * Copyright since 2025 InPost S.A.
 *
 * For the full license information, please view the LICENSE file bundled with the module.
 *
 * @author InPost S.A.
 * @copyright since 2025 InPost S.A.
 * @license MIT
 */

declare(strict_types=1);

namespace InPost\International\Delivery\AvailabilityChecker;

use InPost\International\Configuration\Repository\ApiConfigurationRepositoryInterface;
use InPost\International\Entity\Carrier;
use InPost\International\Entity\PointDeliveryCarrier;

if (!defined('_PS_VERSION_')) {
    exit;
}

final class ConfigurationChecker implements CarrierAvailabilityCheckerInterface
{
    /**
     * @var ApiConfigurationRepositoryInterface
     */
    private $repository;

    public function __construct(ApiConfigurationRepositoryInterface $repository)
    {
        $this->repository = $repository;
    }

    public function isAvailable(Carrier $carrier, \Cart $cart): bool
    {
        if (!$carrier instanceof PointDeliveryCarrier) {
            return true;
        }

        return $this->repository->hasConfiguration();
    }
}
